kexec-tools/SOURCES/dracut-kdump.sh

325 lines
7.9 KiB
Bash
Raw Permalink Normal View History

2020-12-15 15:59:59 +00:00
#!/bin/sh
# continue here only if we have to save dump.
if [ -f /etc/fadump.initramfs ] && [ ! -f /proc/device-tree/rtas/ibm,kernel-dump ] && [ ! -f /proc/device-tree/ibm,opal/dump/mpipl-boot ]; then
exit 0
fi
. /lib/dracut-lib.sh
. /lib/kdump-lib-initramfs.sh
set -o pipefail
DUMP_RETVAL=0
export PATH=$PATH:$KDUMP_SCRIPT_DIR
do_dump()
{
local _ret
eval $DUMP_INSTRUCTION
_ret=$?
if [ $_ret -ne 0 ]; then
2021-05-18 06:35:27 +00:00
derror "saving vmcore failed"
2020-12-15 15:59:59 +00:00
fi
return $_ret
}
do_kdump_pre()
{
local _ret
if [ -n "$KDUMP_PRE" ]; then
"$KDUMP_PRE"
_ret=$?
if [ $_ret -ne 0 ]; then
2021-05-18 06:35:27 +00:00
derror "$KDUMP_PRE exited with $_ret status"
2020-12-15 15:59:59 +00:00
return $_ret
fi
fi
# if any script fails, it just raises warning and continues
if [ -d /etc/kdump/pre.d ]; then
for file in /etc/kdump/pre.d/*; do
"$file"
_ret=$?
if [ $_ret -ne 0 ]; then
2021-05-18 06:35:27 +00:00
derror "$file exited with $_ret status"
2020-12-15 15:59:59 +00:00
fi
done
fi
return 0
}
do_kdump_post()
{
local _ret
if [ -d /etc/kdump/post.d ]; then
for file in /etc/kdump/post.d/*; do
"$file" "$1"
_ret=$?
if [ $_ret -ne 0 ]; then
2021-05-18 06:35:27 +00:00
derror "$file exited with $_ret status"
2020-12-15 15:59:59 +00:00
fi
done
fi
if [ -n "$KDUMP_POST" ]; then
"$KDUMP_POST" "$1"
_ret=$?
if [ $_ret -ne 0 ]; then
2021-05-18 06:35:27 +00:00
derror "$KDUMP_POST exited with $_ret status"
2020-12-15 15:59:59 +00:00
fi
fi
}
add_dump_code()
{
DUMP_INSTRUCTION=$1
}
dump_raw()
{
local _raw=$1
[ -b "$_raw" ] || return 1
2021-05-18 06:35:27 +00:00
dinfo "saving to raw disk $_raw"
2020-12-15 15:59:59 +00:00
if ! $(echo -n $CORE_COLLECTOR|grep -q makedumpfile); then
_src_size=`ls -l /proc/vmcore | cut -d' ' -f5`
_src_size_mb=$(($_src_size / 1048576))
monitor_dd_progress $_src_size_mb &
fi
2021-05-18 06:35:27 +00:00
dinfo "saving vmcore"
2020-12-15 15:59:59 +00:00
$CORE_COLLECTOR /proc/vmcore | dd of=$_raw bs=$DD_BLKSIZE >> /tmp/dd_progress_file 2>&1 || return 1
sync
2021-05-18 06:35:27 +00:00
dinfo "saving vmcore complete"
2020-12-15 15:59:59 +00:00
return 0
}
dump_ssh()
{
2021-05-18 06:35:27 +00:00
local _ret=0
local _exitcode=0 _exitcode2=0
2020-12-15 15:59:59 +00:00
local _opt="-i $1 -o BatchMode=yes -o StrictHostKeyChecking=yes"
local _dir="$KDUMP_PATH/$HOST_IP-$DATEDIR"
local _host=$2
2021-05-18 06:35:27 +00:00
local _vmcore="vmcore"
local _ipv6_addr="" _username=""
2020-12-15 15:59:59 +00:00
2021-05-18 06:35:27 +00:00
dinfo "saving to $_host:$_dir"
2020-12-15 15:59:59 +00:00
cat /var/lib/random-seed > /dev/urandom
ssh -q $_opt $_host mkdir -p $_dir || return 1
save_vmcore_dmesg_ssh ${DMESG_COLLECTOR} ${_dir} "${_opt}" $_host
save_opalcore_ssh ${_dir} "${_opt}" $_host
2021-05-18 06:35:27 +00:00
dinfo "saving vmcore"
if is_ipv6_address "$_host"; then
_username=${_host%@*}
_ipv6_addr="[${_host#*@}]"
fi
2020-12-15 15:59:59 +00:00
if [ "${CORE_COLLECTOR%%[[:blank:]]*}" = "scp" ]; then
2021-05-18 06:35:27 +00:00
if [ -n "$_username" ] && [ -n "$_ipv6_addr" ]; then
scp -q $_opt /proc/vmcore "$_username@$_ipv6_addr:$_dir/vmcore-incomplete"
else
scp -q $_opt /proc/vmcore "$_host:$_dir/vmcore-incomplete"
fi
_exitcode=$?
else
2021-11-09 09:53:52 +00:00
$CORE_COLLECTOR /proc/vmcore | ssh $_opt $_host "umask 0077 && dd bs=512 of=$_dir/vmcore-incomplete"
2021-05-18 06:35:27 +00:00
_exitcode=$?
_vmcore="vmcore.flat"
fi
if [ $_exitcode -eq 0 ]; then
ssh $_opt $_host "mv $_dir/vmcore-incomplete $_dir/$_vmcore"
_exitcode2=$?
if [ $_exitcode2 -ne 0 ]; then
derror "moving vmcore failed, _exitcode:$_exitcode2"
else
dinfo "saving vmcore complete"
fi
else
derror "saving vmcore failed, _exitcode:$_exitcode"
fi
dinfo "saving the $KDUMP_LOG_FILE to $_host:$_dir/"
save_log
if [ -n "$_username" ] && [ -n "$_ipv6_addr" ]; then
scp -q $_opt $KDUMP_LOG_FILE "$_username@$_ipv6_addr:$_dir/"
2020-12-15 15:59:59 +00:00
else
2021-05-18 06:35:27 +00:00
scp -q $_opt $KDUMP_LOG_FILE "$_host:$_dir/"
fi
_ret=$?
if [ $_ret -ne 0 ]; then
derror "saving log file failed, _exitcode:$_ret"
fi
if [ $_exitcode -ne 0 ] || [ $_exitcode2 -ne 0 ];then
return 1
2020-12-15 15:59:59 +00:00
fi
return 0
}
save_opalcore_ssh() {
local _path=$1
local _opts="$2"
local _location=$3
2021-05-18 06:35:27 +00:00
local _user_name="" _ipv6addr=""
ddebug "_path=$_path _opts=$_opts _location=$_location"
2020-12-15 15:59:59 +00:00
if [ ! -f $OPALCORE ]; then
# Check if we are on an old kernel that uses a different path
if [ -f /sys/firmware/opal/core ]; then
OPALCORE="/sys/firmware/opal/core"
else
return 0
fi
fi
2021-05-18 06:35:27 +00:00
if is_ipv6_address "$_host"; then
_user_name=${_location%@*}
_ipv6addr="[${_location#*@}]"
fi
dinfo "saving opalcore:$OPALCORE to $_location:$_path"
if [ -n "$_user_name" ] && [ -n "$_ipv6addr" ]; then
scp $_opts $OPALCORE $_user_name@$_ipv6addr:$_path/opalcore-incomplete
else
scp $_opts $OPALCORE $_location:$_path/opalcore-incomplete
fi
2020-12-15 15:59:59 +00:00
if [ $? -ne 0 ]; then
2021-05-18 06:35:27 +00:00
derror "saving opalcore failed"
2020-12-15 15:59:59 +00:00
return 1
fi
ssh $_opts $_location mv $_path/opalcore-incomplete $_path/opalcore
2021-05-18 06:35:27 +00:00
dinfo "saving opalcore complete"
2020-12-15 15:59:59 +00:00
return 0
}
save_vmcore_dmesg_ssh() {
local _dmesg_collector=$1
local _path=$2
local _opts="$3"
local _location=$4
2021-05-18 06:35:27 +00:00
dinfo "saving vmcore-dmesg.txt to $_location:$_path"
2021-11-09 09:53:52 +00:00
$_dmesg_collector /proc/vmcore | ssh $_opts $_location "umask 0077 && dd of=$_path/vmcore-dmesg-incomplete.txt"
2020-12-15 15:59:59 +00:00
_exitcode=$?
if [ $_exitcode -eq 0 ]; then
ssh -q $_opts $_location mv $_path/vmcore-dmesg-incomplete.txt $_path/vmcore-dmesg.txt
2021-05-18 06:35:27 +00:00
dinfo "saving vmcore-dmesg.txt complete"
2020-12-15 15:59:59 +00:00
else
2021-05-18 06:35:27 +00:00
derror "saving vmcore-dmesg.txt failed"
2020-12-15 15:59:59 +00:00
fi
}
get_host_ip()
{
local _host
if is_nfs_dump_target || is_ssh_dump_target
then
kdumpnic=$(getarg kdumpnic=)
2021-05-18 06:35:27 +00:00
[ -z "$kdumpnic" ] && derror "failed to get kdumpnic!" && return 1
2020-12-15 15:59:59 +00:00
_host=`ip addr show dev $kdumpnic|grep '[ ]*inet'`
2021-05-18 06:35:27 +00:00
[ $? -ne 0 ] && derror "wrong kdumpnic: $kdumpnic" && return 1
2020-12-15 15:59:59 +00:00
_host=`echo $_host | head -n 1 | cut -d' ' -f2`
_host="${_host%%/*}"
2021-05-18 06:35:27 +00:00
[ -z "$_host" ] && derror "wrong kdumpnic: $kdumpnic" && return 1
2020-12-15 15:59:59 +00:00
HOST_IP=$_host
fi
return 0
}
read_kdump_conf()
{
if [ ! -f "$KDUMP_CONF" ]; then
2021-05-18 06:35:27 +00:00
derror "$KDUMP_CONF not found"
2020-12-15 15:59:59 +00:00
return
fi
get_kdump_confs
# rescan for add code for dump target
while read config_opt config_val;
do
# remove inline comments after the end of a directive.
case "$config_opt" in
dracut_args)
config_val=$(get_dracut_args_target "$config_val")
if [ -n "$config_val" ]; then
config_val=$(get_mntpoint_from_target "$config_val")
add_dump_code "dump_fs $config_val"
fi
;;
ext[234]|xfs|btrfs|minix|nfs)
config_val=$(get_mntpoint_from_target "$config_val")
add_dump_code "dump_fs $config_val"
;;
raw)
add_dump_code "dump_raw $config_val"
;;
ssh)
add_dump_code "dump_ssh $SSH_KEY_LOCATION $config_val"
;;
esac
done <<< "$(read_strip_comments $KDUMP_CONF)"
}
fence_kdump_notify()
{
if [ -n "$FENCE_KDUMP_NODES" ]; then
$FENCE_KDUMP_SEND $FENCE_KDUMP_ARGS $FENCE_KDUMP_NODES &
fi
}
read_kdump_conf
fence_kdump_notify
get_host_ip
if [ $? -ne 0 ]; then
2021-05-18 06:35:27 +00:00
derror "get_host_ip exited with non-zero status!"
2020-12-15 15:59:59 +00:00
exit 1
fi
if [ -z "$DUMP_INSTRUCTION" ]; then
add_dump_code "dump_fs $NEWROOT"
fi
do_kdump_pre
if [ $? -ne 0 ]; then
2021-05-18 06:35:27 +00:00
derror "kdump_pre script exited with non-zero status!"
2020-12-15 15:59:59 +00:00
do_final_action
# During systemd service to reboot the machine, stop this shell script running
exit 1
fi
make_trace_mem "kdump saving vmcore" '1:shortmem' '2+:mem' '3+:slab'
do_dump
DUMP_RETVAL=$?
do_kdump_post $DUMP_RETVAL
if [ $? -ne 0 ]; then
2021-05-18 06:35:27 +00:00
derror "kdump_post script exited with non-zero status!"
2020-12-15 15:59:59 +00:00
fi
if [ $DUMP_RETVAL -ne 0 ]; then
exit 1
fi
do_final_action